""" This Script attempts to create an ANUGA Domain 

from two files containing Points & Vertices of a triangular mesh


"""

#------------------------------------------------------------------------------
# Import necessary modules
#------------------------------------------------------------------------------
print ' ABOUT to Start Simulation:- Importing Modules'

# Standard modules
import os
import time
import sys

# Related major packages
from anuga.shallow_water import Domain
from anuga.shallow_water import Reflective_boundary
from anuga.shallow_water import Dirichlet_boundary
from anuga.shallow_water import Time_boundary
from anuga.shallow_water import Transmissive_Momentum_Set_Stage_boundary
from anuga.abstract_2d_finite_volumes.util import file_function
from anuga.pmesh.mesh_interface import create_mesh_from_regions
from anuga.shallow_water.data_manager import convert_dem_from_ascii2netcdf
from anuga.shallow_water.data_manager import dem2pts
from anuga.geospatial_data.geospatial_data import Geospatial_data
from anuga.shallow_water.shallow_water_domain import Inflow
#import inflow_test
from anuga.utilities.polygon import read_polygon
from anuga.shallow_water.shallow_water_domain import Rainfall

# OLE How do I get the Domain Points to create a LIST of Points from the File ???
import Numeric

#------------------------------------------------------------------------------
#    CREATE DOMAIN from Mesh created ELSEWHERE
#------------------------------------------------------------------------------




points=[]
fid = open('ANUGA_MeshPts.csv')
for lines in fid.readlines():
    if lines.strip() == '': continue
    fields = lines.split(',')
    x = float(fields[0])
    y = float(fields[1])
    points.append([x,y])
fid.close()

vertices = []
fid = open('ANUGA_MeshVertices.csv')    
for lines in fid.readlines():
    if lines.strip() == '': continue
    fields = lines.split(',')
    i = int(fields[0])
    j = int(fields[1])
    k = int(fields[2])    
    vertices.append([i,j,k])
fid.close()

boundary=None  # Deal with this later

#print points
#print vertices
domain = Domain(points, vertices, boundary) # Create domain
domain.check_integrity()

#------------------------------------------------------------------------------
#         ASSIGN Elevations to the MESH
#------------------------------------------------------------------------------



#------------------------------------------------------------------------------
#       ASSIGN MANNING Roughness to the MESH
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
#       ASSIGN FORCING FUNCTIONS As required
#------------------------------------------------------------------------------


#------------------------------------------------------------------------------
#       BOUNDARY CONDITIONS
#------------------------------------------------------------------------------

Br = Reflective_boundary(domain)
domain.set_boundary({'exterior': Br})  # Default tag

#------------------------------------------------------------------------------
# Evolve system through time
#------------------------------------------------------------------------------

import time
t0 = time.time()

for t in domain.evolve(yieldstep = 10, finaltime = 100): 
    domain.write_time()
    domain.write_boundary_statistics(quantities='stage')     

print 'That took', time.time() - t0, 'seconds'			
    
